// Export du symbole fac_asm pour utilisation possible dans d'autres
// fichiers i.e src/q1/bs.c
.global fac_asm

fac_asm:

  // Sauvergarde et définition du contexte
  push %rbp
  mov %rsp, %rbp

  // Calcul de facturielle
  // paramètre : x dans %rax
  // retour : placé dans %rax

  // Incrément i
  mov $0x2, %rbx

  // Résultat
  mov $0x1, %rcx

  // Boucle for
for:
  cmp %rax, %rbx
  jg endfor

  // Cœur de la boucle
  imul %rbx, %rcx

  // Incrémentation de l'incrément
  inc %rbx

  // Fin de la boucle for on revient au test
  jmp for

endfor:
  // Copie du résultat dans %rax
  mov %rcx, %rax

  // Restauration du contexte
  leave
  // retour de la fonction
  ret
